VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsComputermensch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Dieser Sourcecode stammt von Nils-Philip Jermann.
'Er wurde fr die Auschreibung von ActiveVB
'"Einfache KI entwickeln" programmiert.
' 2004 Nils-Philip Jermann

Option Explicit

Private Declare Function EbExecuteLine Lib "vba6.dll" (ByVal StringToExec As Long, ByVal Any1 As Long, ByVal Any2 As Long, ByVal CheckOnly As Long) As Long

Public Rechenergebnis As Double

Private Wort() As typWort
Private Type typWort
  Wort As String
  Worttyp As enuWorttyp
End Type

Private Witz() As String

Public Enum enuWorttyp
  Begrung = 0
  Verabschiedendigung = 1
  Beschimpfung = 2
  Personalpronomen = 3
  WFragewort = 4
  Hilfsverb = 5
  Artikel = 6
End Enum

Private Gedchnis() As typGedchnis
Private Type typGedchnis
  Wertname As String
  Wert As String
End Type

Private Sub Class_Initialize()
  'Zufallsgenerator initialisieren
  Randomize Timer
  'Wrter auslesen
  Dim Zeile As String, Worttyp As enuWorttyp
  Open App.Path & "\Bot\Wrter.txt" For Input As 1
  ReDim Wort(0)
  Do
    Line Input #1, Zeile
    If Left$(Zeile, 1) = "<" Then
      Worttyp = ToLong(Zeile)
    Else
      ReDim Preserve Wort(UBound(Wort) + 1)
      Wort(UBound(Wort)).Wort = Zeile
      Wort(UBound(Wort)).Worttyp = Worttyp
    End If
  Loop Until EOF(1)
  Close 1
  '
  ReDim Gedchnis(0)
  'Witze auslesen
  Witz = Split(ReadFile(App.Path & "\Bot\Witze.txt"), vbNewLine)
End Sub

'Die Hauptfunktion, der man den Satz bergibt, der verarbeitet werden soll.
Public Function Hren(ByVal Text As String, Optional ByVal Antwort As Boolean = True) As String
  'Satz fr die sptere erkennung richtig prparieren.
  Text = Bereinigen(Text)
  'Text auf verschidende Textarten prfen
  If IstWorttyp(NimmWort(Text, 0), Begrung) Then
    Hren = NimmWortVonWorttyp(Begrung)
    
  ElseIf IstWorttyp(NimmWort(Text, 0), Verabschiedendigung) Then
    Hren = NimmWortVonWorttyp(Verabschiedendigung)

  ElseIf IstWorttyp(NimmWort(Text, 0), Beschimpfung) Then
    Hren = "Was soll denn diese Beschimpfung? Ich habe dir doch gar nichts getan!"
  
    ElseIf IstWorttyp(NimmWort(Text, 0), WFragewort) And IstWorttyp(NimmWort(Text, 1), Hilfsverb) And IstWorttyp(NimmWort(Text, 2), Artikel) Then
    Dim i As Long
    For i = 0 To UBound(Gedchnis)
      If Gedchnis(i).Wertname = NimmWort(Text, 3) Then
        Hren = Gedchnis(i).Wert & "."
        Exit For
      End If
    Next
    If Hren = "" Then Hren = "Das wei ich nicht."

  ElseIf IstWorttyp(NimmWort(Text, 0), WFragewort) And IstWorttyp(NimmWort(Text, 1), Hilfsverb) Then
    For i = 0 To UBound(Gedchnis)
      If Gedchnis(i).Wertname = NimmWort(Text, 2) Then
        Hren = Gedchnis(i).Wert & "."
        Exit For
      End If
    Next
    If Hren = "" Then Hren = "Das wei ich nicht."
    
  ElseIf IstWorttyp(NimmWort(Text, 0), Artikel) And IstWorttyp(NimmWort(Text, 2), Hilfsverb) Then
    GedchnisAdd NimmWort(Text, 1), NimmWort(Text, 3)
    Select Case Rnd
    Case 0 To 0.4
      Hren = "Aha!"
    Case 0.4 To 0.6
      Hren = "Gut, das ich das jetzt wei."
    Case 0.6 To 0.8
      Hren = "Das werde ich mir merken."
    Case 0.8 To 1
      Hren = "Aso."
    End Select
    
  ElseIf IstWorttyp(NimmWort(Text, 1), Hilfsverb) Then
    GedchnisAdd NimmWort(Text, 0), NimmWort(Text, 2)
    Select Case Rnd
    Case 0 To 0.4
      Hren = "Aha!"
    Case 0.4 To 0.6
      Hren = "Gut, das ich das jetzt wei."
    Case 0.6 To 0.8
      Hren = "Das werde ich mir merken."
    Case 0.8 To 1
      Hren = "Aso."
    End Select
    
  ElseIf Text = "wer bist du" Or Text = "info" Then
    Hren = "Mein Name ist Peedy. Ich wurde von Microsoft entwickelt. Meine KI wurde von Nils-Philip Jermann geschrieben."
    
  ElseIf Text Like "wie viel ist *" Then
    Calc NimmWort(Text, 3)
    Hren = "Das ist " & Rechenergebnis
  
  ElseIf Text = "welches datum ist heute" Then
    Hren = "Heute ist " & WeekdayName(Weekday(Date)) & " der " & Date & "."
  
  ElseIf Text = "wie spt ist es" Then
    Hren = "Es ist jetzt " & TimeValue(Time) & "."
  
  ElseIf Text Like "ffne bitte die Datei *" Then
    
    
  ElseIf Text = "erzhl einen witz" Then
    Hren = Witz(Rnd * UBound(Witz))
  
  Else
   Hren = "Das verstehe ich nicht."
  End If
Exit Function
Fehler:
  Hren = "Das verstehe ich nicht."
End Function

'Lst eine Rechenaufgabe
Private Sub Calc(ByVal Aufgabe As String)
  EbExecuteLine StrPtr("frmEinAusgabe.Computermensch.Rechenergebnis = CDbl(" & Aufgabe & ")"), 0, 0, 0
End Sub

'Liest die angegebene Datei aus und gibt den Inhalt zurck.
Public Function ReadFile(ByVal Dateipfad As String, Optional Startbyte As Long = 1, Optional Lnge As Long = -1) As String
  On Error Resume Next
  Dim Dateinummer As Integer
  Dim Puffer As String
  Dateinummer = FreeFile
  If Lnge = -1 Then Lnge = FileLen(Dateipfad)
  Puffer = Space$(Lnge)
  Open Dateipfad For Binary Lock Read Write As #Dateinummer
  Get #Dateinummer, Startbyte, Puffer
  ReadFile = Puffer
  Puffer = ""
  Close Dateinummer
End Function

'Fgt zum virtuellen Gedchnis einen Eintrag hinzu.
Private Sub GedchnisAdd(ByVal Wertname As String, ByVal Wert As String)
  Dim i As Long
  i = UBound(Gedchnis)
  ReDim Preserve Gedchnis(i + 1)
  Gedchnis(i).Wertname = Wertname
  Gedchnis(i).Wert = Wert
End Sub

'Bereinigt einen Text.
Private Function Bereinigen(ByVal Text As String) As String
  Dim i As Long
  Const Satzzeichen As String = ",;:.!?-"
  Text = Replace(Text, "", "ss")
  For i = 1 To Len(Satzzeichen)
    Text = Replace(Text, Mid$(Satzzeichen, i, 1), "")
  Next
  Bereinigen = LCase$(Trim$(Text))
End Function

'Gibt die Anzahl die Wrter aus einem Ausdruck zurck.
Public Function WrterAnzahl(ByVal Ausdruck As String) As Long
  WrterAnzahl = UBound(Split(Ausdruck, " ")) + 1
End Function

'Gibt ein einzelnes Wort aus einem Ausdruck zurck.
Public Function NimmWort2(ByVal Text As String, ByVal Index As Long) As String
  On Error Resume Next
  Text = Text & " "
  NimmWort2 = Split(Text, " ")(Index)
  NimmWort2 = Bereinigen(NimmWort2)
End Function

Public Function NimmWort(ByVal Text As String, ByVal Index As Long) As String
  Dim i As Long
  Dim Wortzhler As Long
  Dim InAnfhrungszeichen As Boolean
  For i = 1 To Len(Text)
    If Mid$(Text, i, 1) = " " And Not InAnfhrungszeichen Then
      If Not InAnfhrungszeichen And Mid$(Text, i + 1, 1) <> """" Then Wortzhler = Wortzhler + 1
    ElseIf Mid$(Text, i, 1) = """" Then
      If Not InAnfhrungszeichen And i > 1 Then Wortzhler = Wortzhler + 1
      InAnfhrungszeichen = Not InAnfhrungszeichen
    Else
      If Wortzhler = Index Then NimmWort = NimmWort & Mid$(Text, i, 1)
    End If
  Next i
End Function

'Gibt zurck, ob das angegebene Wort den angegebenen Worttyp hat.
Private Function IstWorttyp(ByVal Text As String, ByVal Worttyp As enuWorttyp) As Boolean
  Dim i As Long
  For i = 0 To UBound(Wort)
    If Bereinigen(Wort(i).Wort) = Bereinigen(Text) Then
      If Wort(i).Worttyp = Worttyp Then
        IstWorttyp = True
        Exit Function
      End If
    End If
  Next
End Function

'Gibt ein Ausdruck aus einer Liste von Ausdrcken zurck.
Private Function NimmWortVonWorttyp(ByVal Worttyp As enuWorttyp) As String
  Dim i As Long
  For i = 0 To UBound(Wort)
    If Wort(i).Worttyp = Worttyp Then
      NimmWortVonWorttyp = Wort(i).Wort
    End If
  Next
End Function

Public Function ToLong(ByVal Value As String) As Long
  Dim i As Long
  Dim Rckgabe As String
  For i = 1 To Len(Value)
    Select Case Mid$(Value, i, 1)
    Case "0" To "9"
      Rckgabe = Rckgabe & Mid$(Value, i, 1)
    End Select
  Next
  If Rckgabe = "" Then Rckgabe = "0"
  ToLong = CLng(Rckgabe)
End Function
