VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsFileAccess"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private lngFileNum As Long

Public Sub OpenFile(FileName As String, OpenFor As Integer) 'ffnet die Datei
On Error GoTo Fehler

lngFileNum = FreeFile
Select Case OpenFor
    Case 0 'Input
        Open FileName For Input As #lngFileNum
    Case 1 'Output
        Open FileName For Output As #lngFileNum
    Case 2 'Append
        Open FileName For Append As #lngFileNum
End Select

Exit Sub

Fehler:
MsgBox "Fehlernummer: " & Err.Number & vbNewLine & "Fehlerbeschreibung: " & Err.Description & vbNewLine & "Fehlerherkunft: " & Err.Source
End Sub

Public Sub CloseFile() 'Schliet die Datei
On Error GoTo Fehler

Close #lngFileNum

Exit Sub

Fehler:
MsgBox "Fehlernummer: " & Err.Number & vbNewLine & "Fehlerbeschreibung: " & Err.Description & vbNewLine & "Fehlerherkunft: " & Err.Source
End Sub

Public Property Get ReadAll() As String 'Liet alles aus der datei aus
On Error GoTo Fehler

Dim Puffer(1) As String

While Not EOF(lngFileNum)
    Line Input #lngFileNum, Puffer(0)
    Puffer(1) = Puffer(1) & Puffer(0) & vbNewLine
Wend

ReadAll = Puffer(1)

Exit Property

Fehler:
MsgBox "Fehlernummer: " & Err.Number & vbNewLine & "Fehlerbeschreibung: " & Err.Description & vbNewLine & "Fehlerherkunft: " & Err.Source
End Property

Public Sub Save(Puffer As String) 'speichert in die Datei
On Error GoTo Fehler

Print #lngFileNum, Puffer

Exit Sub

Fehler:
MsgBox "Fehlernummer: " & Err.Number & vbNewLine & "Fehlerbeschreibung: " & Err.Description & vbNewLine & "Fehlerherkunft: " & Err.Source
End Sub
