VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsKI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'====================================================================================
'Autor:     Richard Lamboj
'Projekt:   KI
'Version:   1.0
'Lizenz:    Open Source GNU Lizenz
'E-Mail:    Penguin@Penguin-Network.net
'Homepage:  http://www.penguin-network.net
'====================================================================================

Dim Module()        As String
Dim Componente()    As String
Dim Formelrechner   As New frmFormelrechner
Public Sub Ki(Satz As String, SC As ScriptControl, frmForm As frmKI)
On Error GoTo Fehler

Dim tmp() As String

Satz = LCase(Satz)
Satz = Trim(Satz)

tmp = Split(Satz, " ")

Select Case tmp(0)
    Case "/formel" 'startet den Formelrechner
        Set Formelrechner = New frmFormelrechner
        Formelrechner.Show
    Case "/rechnung" 'fhrt eien Berechnung durch
        frmForm.rtbAusgabe.Text = frmForm.rtbAusgabe.Text & "Ergebnis: " & SC.Eval(tmp(1)) & vbNewLine
End Select

For i = 0 To UBound(Module)
    If Not Module(i) = "" Then
        SC.ExecuteStatement Module(i) 'Fhrt die Module aus
    End If
Next i

Exit Sub

Fehler:
MsgBox "Fehlernummer: " & Err.Number & vbNewLine & "Fehlerbeschreibung: " & Err.Description & vbNewLine & "Fehlerherkunft: " & Err.Source
End Sub

Public Sub AddModule(Pfad As String)
On Error GoTo Fehler

Dim Puffer As String

If Not Pfad = "" Then
    Open Pfad For Input As #1
        While Not EOF(1)
            Line Input #1, Puffer
            Module(UBound(Module)) = Module(UBound(Module)) & Puffer & vbCrLf
        Wend
    Close #1
    ReDim Preserve Module(UBound(Module) + 1)
End If

Exit Sub

Fehler:
MsgBox "Fehlernummer: " & Err.Number & vbNewLine & "Fehlerbeschreibung: " & Err.Description & vbNewLine & "Fehlerherkunft: " & Err.Source
End Sub

Public Sub AddComponente(Pfad As String, SC As Object)
On Error GoTo Fehler

Dim Puffer As String

If Not Pfad = "" Then
    Open Pfad For Input As #1
        While Not EOF(1)
            Line Input #1, Puffer
            Componente(UBound(Componente)) = Componente(UBound(Componente)) & Puffer & vbCrLf
        Wend
    Close #1
    SC.AddCode Componente(UBound(Componente))
    ReDim Preserve Componente(UBound(Componente) + 1)
End If

Exit Sub

Fehler:
MsgBox "Fehlernummer: " & Err.Number & vbNewLine & "Fehlerbeschreibung: " & Err.Description & vbNewLine & "Fehlerherkunft: " & Err.Source
End Sub

Private Sub Class_Initialize()
On Error GoTo Fehler

ReDim Preserve Module(0)
ReDim Preserve Componente(0)

Exit Sub

Fehler:
MsgBox "Fehlernummer: " & Err.Number & vbNewLine & "Fehlerbeschreibung: " & Err.Description & vbNewLine & "Fehlerherkunft: " & Err.Source
End Sub
